<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (63)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="f.prototype">F.prototype</h1>
    <p>
      Remember, new objects can be created with a constructor function, like
      <code>new F()</code>.
    </p>
    <p>
      If <code>F.prototype</code> is an object, then the
      <code>new</code> operator uses it to set <code>[[Prototype]]</code> for
      the new object.
    </p>
    <pre
      class="smart"
    ><code>JavaScript had prototypal inheritance from the beginning. It was one of the core features of the language.

But in the old times, there was no direct access to it. The only thing that worked reliably was a `&quot;prototype&quot;` property of the constructor function, described in this chapter. So there are many scripts that still use it.</code></pre>
    <p>
      Please note that <code>F.prototype</code> here means a regular property
      named <code>"prototype"</code> on <code>F</code>. It sounds something
      similar to the term “prototype”, but here we really mean a regular
      property with this name.
    </p>
    <p>Here’s the example:</p>
    <p>```js run let animal = { eats: true };</p>
    <p>function Rabbit(name) { this.name = name; }</p>
    <p><em>!</em> Rabbit.prototype = animal; <em>/!</em></p>
    <p>
      let rabbit = new Rabbit(“White Rabbit”); // rabbit.__proto__ == animal
    </p>
    <p>alert( rabbit.eats ); // true ```</p>
    <p>
      Setting <code>Rabbit.prototype = animal</code> literally states the
      following: “When a <code>new Rabbit</code> is created, assign its
      <code>[[Prototype]]</code> to <code>animal</code>”.
    </p>
    <p>That’s the resulting picture:</p>
    <p><img src="proto-constructor-animal-rabbit.svg" /></p>
    <p>
      On the picture, <code>"prototype"</code> is a horizontal arrow, meaning a
      regular property, and <code>[[Prototype]]</code> is vertical, meaning the
      inheritance of <code>rabbit</code> from <code>animal</code>.
    </p>
    <p>
      ``<code>smart header="</code>F.prototype<code>only used at</code>new
      F<code>time"</code>F.prototype<code>property is only used when</code>new
      F<code>is called, it assigns</code>[[Prototype]]` of the new object.
    </p>
    <p>
      If, after the creation, <code>F.prototype</code> property changes (<code
        >F.prototype = &lt;another object&gt;</code
      >), then new objects created by <code>new F</code> will have another
      object as <code>[[Prototype]]</code>, but already existing objects keep
      the old one.
    </p>
    <pre><code>
## Default F.prototype, constructor property

Every function has the `&quot;prototype&quot;` property even if we don&#39;t supply it.

The default `&quot;prototype&quot;` is an object with the only property `constructor` that points back to the function itself.

Like this:

```js
function Rabbit() {}

/* default prototype
Rabbit.prototype = { constructor: Rabbit };
*/</code></pre>
    <p><img src="function-prototype-constructor.svg" /></p>
    <p>We can check it:</p>
    <p>
      ```js run function Rabbit() {} // by default: // Rabbit.prototype = {
      constructor: Rabbit }
    </p>
    <p>alert(Rabbit.prototype.constructor == Rabbit); // true ```</p>
    <p>
      Naturally, if we do nothing, the <code>constructor</code> property is
      available to all rabbits through <code>[[Prototype]]</code>:
    </p>
    <p>
      ```js run function Rabbit() {} // by default: // Rabbit.prototype = {
      constructor: Rabbit }
    </p>
    <p>let rabbit = new Rabbit(); // inherits from {constructor: Rabbit}</p>
    <p>alert(rabbit.constructor == Rabbit); // true (from prototype) ```</p>
    <p><img src="rabbit-prototype-constructor.svg" /></p>
    <p>
      We can use <code>constructor</code> property to create a new object using
      the same constructor as the existing one.
    </p>
    <p>Like here:</p>
    <p>```js run function Rabbit(name) { this.name = name; alert(name); }</p>
    <p>let rabbit = new Rabbit(“White Rabbit”);</p>
    <p>
      <em>!</em> let rabbit2 = new rabbit.constructor(“Black Rabbit”);
      <em>/!</em> ```
    </p>
    <p>
      That’s handy when we have an object, don’t know which constructor was used
      for it (e.g. it comes from a 3rd party library), and we need to create
      another one of the same kind.
    </p>
    <p>
      But probably the most important thing about <code>"constructor"</code> is
      that…
    </p>
    <p>
      <strong
        >…JavaScript itself does not ensure the right
        <code>"constructor"</code> value.</strong
      >
    </p>
    <p>
      Yes, it exists in the default <code>"prototype"</code> for functions, but
      that’s all. What happens with it later – is totally on us.
    </p>
    <p>
      In particular, if we replace the default prototype as a whole, then there
      will be no <code>"constructor"</code> in it.
    </p>
    <p>For instance:</p>
    <p>```js run function Rabbit() {} Rabbit.prototype = { jumps: true };</p>
    <p>
      let rabbit = new Rabbit(); <em>!</em> alert(rabbit.constructor ===
      Rabbit); // false <em>/!</em> ```
    </p>
    <p>
      So, to keep the right <code>"constructor"</code> we can choose to
      add/remove properties to the default <code>"prototype"</code> instead of
      overwriting it as a whole:
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">function</span> <span class="at">Rabbit</span>() <span class="op">{}</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="co">// Not overwrite Rabbit.prototype totally</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="co">// just add to it</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="va">Rabbit</span>.<span class="va">prototype</span>.<span class="at">jumps</span> <span class="op">=</span> <span class="kw">true</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-6" title="6"><span class="co">// the default Rabbit.prototype.constructor is preserved</span></a></code></pre>
    </div>
    <p>
      Or, alternatively, recreate the <code>constructor</code> property
      manually:
    </p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="va">Rabbit</span>.<span class="at">prototype</span> <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="dt">jumps</span><span class="op">:</span> <span class="kw">true</span><span class="op">,</span></a>
<a class="sourceLine" id="cb4-3" title="3"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb4-4" title="4">  <span class="dt">constructor</span><span class="op">:</span> Rabbit</a>
<a class="sourceLine" id="cb4-5" title="5"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb4-6" title="6"><span class="ss">};</span></a>
<a class="sourceLine" id="cb4-7" title="7"></a>
<a class="sourceLine" id="cb4-8" title="8"><span class="ss">// now constructor is also correct, because we added it</span></a></code></pre>
    </div>
    <h2 id="summary">Summary</h2>
    <p>
      In this chapter we briefly described the way of setting a
      <code>[[Prototype]]</code> for objects created via a constructor function.
      Later we’ll see more advanced programming patterns that rely on it.
    </p>
    <p>Everything is quite simple, just a few notes to make things clear:</p>
    <ul>
      <li>
        The <code>F.prototype</code> property (don’t mistake it for
        <code>[[Prototype]]</code>) sets <code>[[Prototype]]</code> of new
        objects when <code>new F()</code> is called.
      </li>
      <li>
        The value of <code>F.prototype</code> should be either an object or
        <code>null</code>: other values won’t work.
      </li>
      <li>
        The <code>"prototype"</code> property only has such a special effect
        when set on a constructor function, and invoked with <code>new</code>.
      </li>
    </ul>
    <p>On regular objects the <code>prototype</code> is nothing special:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">let</span> user <span class="op">=</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="dt">name</span><span class="op">:</span> <span class="st">&quot;John&quot;</span><span class="op">,</span></a>
<a class="sourceLine" id="cb5-3" title="3">  <span class="dt">prototype</span><span class="op">:</span> <span class="st">&quot;Bla-bla&quot;</span><span class="op">,</span> <span class="co">// no magic at all</span></a>
<a class="sourceLine" id="cb5-4" title="4"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      By default all functions have
      <code>F.prototype = { constructor: F }</code>, so we can get the
      constructor of an object by accessing its
      <code>"constructor"</code> property.
    </p>
  </body>
</html>
